#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ResourceType {
    #[serde(rename = "ASSET")]
    Asset,
    #[serde(rename = "RUN")]
    Run,
    #[serde(rename = "WORKBOOK")]
    Workbook,
    #[serde(rename = "CHECKLIST")]
    Checklist,
    #[serde(rename = "TEMPLATE")]
    Template,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ResourceType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ResourceType::Asset => "ASSET",
            ResourceType::Run => "RUN",
            ResourceType::Workbook => "WORKBOOK",
            ResourceType::Checklist => "CHECKLIST",
            ResourceType::Template => "TEMPLATE",
            ResourceType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ResourceType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ResourceType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ResourceType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<ResourceType, conjure_object::plain::ParseEnumError> {
        match v {
            "ASSET" => Ok(ResourceType::Asset),
            "RUN" => Ok(ResourceType::Run),
            "WORKBOOK" => Ok(ResourceType::Workbook),
            "CHECKLIST" => Ok(ResourceType::Checklist),
            "TEMPLATE" => Ok(ResourceType::Template),
            v => v.parse().map(|v| ResourceType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ResourceType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ResourceType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ResourceType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
